#!/usr/bin/python
# -*- coding: utf8 -*-
import Image
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from main_win import *
from statusconf import *
from configuration import *
from about import *
from firsttime import *


class Gui_Main(QMainWindow,Ui_MainWindow) : #OK QT4
    def __init__(self, parent=None):
        super(Gui_Main, self).__init__(parent)
        self.setupUi(self)

class FirstTime(QDialog,Ui_FirstTime) : #OK QT4
    def __init__(self, parent=None):
        super(FirstTime, self).__init__(parent)
        self.setupUi(self)

class StatusConf(QDialog,Ui_statusconf) : #OK QT4
    def __init__(self, parent=None):
        super(StatusConf, self).__init__(parent)
        self.setupUi(self)

class Configuration(QDialog,Ui_Configuration) : #OK QT4
    def __init__(self, parent=None):
        super(Configuration, self).__init__(parent)
        self.setupUi(self)

class About(QDialog,Ui_about) : #OK QT4
    def __init__(self, parent=None):
        super(About, self).__init__(parent)
        self.setupUi(self)

class QComboTable(QComboBox) :
    def __init__(self,row=-1,parent=None) :
      super(QComboTable,self).__init__(parent)
      self.row=row
      self.connect(self,SIGNAL("currentIndexChanged(int)"),self.sigChanged)
      
    def setRow(self,row) :
      self.row=row
      
    def sigChanged(self) :
      self.index=self.currentIndex()
      self.emit(SIGNAL("QCBchanged"),self.index,self.row)

class myLabel(QLabel) :
    def __init__(self,urlim,scene=None,col=0,time=5,bgfile="essai",bgcolor=256,typet=0,opttransi=0,speedt=3,imgwide=0,zoom=0,hd=0,parent=None) :
      super(myLabel,self).__init__(parent)
      self.scene=scene
      self.imgwide=imgwide
      if imgwide == 1 :
        self.wpix=133
        if hd==3 :
          self.imgwidth=1280
          self.imgheight=720
          self.txtzoom=4.2
          self.txtwide=300
        elif hd==4 :
          self.imgwidth=1920
          self.imgheight=1080
          self.txtzoom=6.9
          self.txtwide=275
        elif hd==5 :
          self.imgwidth=512
          self.imgheight=288
          self.txtzoom=1.5
          self.txtwide=335
        else :
          self.imgwidth=1024
          self.imgheight=576
          self.txtzoom=3.1
          self.txtwide=330
      else :
        self.wpix=100
        if hd==3 :
          self.imgwidth=1280
          self.imgheight=960
          self.txtzoom=4.1
          self.txtwide=312
        elif hd==4 :
          self.imgwidth=1920
          self.imgheight=1440
          self.txtzoom=6.4
          self.txtwide=298
        elif hd==5 :
          self.imgwidth=384
          self.imgheight=288
          self.txtzoom=1.2
          self.txtwide=310
        else :
          self.imgwidth=768
          self.imgheight=576
          self.txtzoom=2.5
          self.txtwide=310
      self.hpix=75
      self.urlim=urlim
      self.col=col
      self.time=time
      self.bgfile=bgfile
      self.bgcolor=bgcolor
      self.typet=typet
      self.opttransi=opttransi
      self.speedt=speedt
      self.zoom=zoom
      self.updatePix()
    
    def updatePix(self) :
      dessin=QImage(self.wpix,self.hpix,QImage.Format_RGB32)
      select=self.selectItem()
      self.scene.clearSelection()
      self.scene.render(QPainter(dessin)) 
      if select != None :
        select.setSelected(1)
      pix=QPixmap.fromImage(dessin)
      self.setPixmap(pix)
    
    def export2ppm(self,url,w=720,h=576,ws=768,hs=576) :
      if self.zoom==2 :
        self.strtStpZoom(url,w,h)
      else :  
        dessin=QImage(w,h,QImage.Format_RGB32)
        self.scene.clearSelection()
        self.scene.render(QPainter(dessin),QRectF(0,0,w,h),QRectF(0,0,ws,hs),Qt.IgnoreAspectRatio) 
        dessin.save(url,"PPM",100)
    
    def selectItem(self) :
        items=self.scene.selectedItems()
        if len(items)==1 :
          return items[0]
        return None
    
    def Qscene(self) :
      return self.scene

    def setQscene(self,scene) :
      self.scene=scene
      self.updatePix()
      
    def copy(self) :
      cp=myLabel(self.urlim,self.scene,self.col,self.time,self.bgfile,self.bgcolor,self.typet,self.opttransi,self.speedt,self.imgwide)
      return cp
    
    def imagetime(self,videof) :
      if videof==1 :
        imgpsec=30
      else:
        imgpsec=25
      if self.typet < 1 :
        framt=0
      else :
        dicspeed={"0":1,"1":2,"2":4,"3":5,"4":10,"5":20}
        speedtrans=dicspeed[str(self.speedt)]
        framt = 100 / speedtrans
      nbrframe=int(self.time) * imgpsec
      imgt=int(self.time) + (framt*imgpsec) 
      return (imgt,nbrframe,framt)

# Functions for zoom and travel
    def setZoom(self) :
      if self.zoom == 0 :
        self.composeZoom=QGraphicsScene()
        pix=QPixmap(self.urlim)
        self.composeZoom.setSceneRect(QRectF(pix.rect()))
        self.composeZoom.addPixmap(pix)
      return self.composeZoom
      
    def setChkZoom(self,chk) :
      self.zoom=chk

    def setZoomBox(self,x,y,w,h,se=1) :
      if se == 1 :
        col=QColor(255,0,0)
        dt="startZoom"
      else :
        col=QColor(0,0,255)
        dt="endZoom"
      pen=QPen(col)
      pen.setWidth(6)
      cadre=self.composeZoom.addRect(x,y,w,h,pen)
      cadre.setFlags(QGraphicsItem.ItemIsMovable | QGraphicsItem.ItemIsSelectable)
      cadre.setZValue(101)
      cadre.setAcceptDrops(1)
      data=QVariant(dt)
      cadre.setData(0,data)
      
    def selectZoomBox(self,se) :
      if se == 1 :
        idf="startZoom"
      else :
        idf="endZoom"
      for item in self.composeZoom.items() :
        if (item.data(0).toString() == idf) :
          return item
      return None
      
    def getZoomBoxInfo(self,se) :
      item=self.selectZoomBox(se)
      if item != None :
        X=item.sceneBoundingRect()
        coord=str(X.x())+":"+str(X.y())+":"+str(X.width())+":"+str(X.height())
        return coord
      return None
      
    def strtStpZoom(self,url,w,h) :
      item=self.selectZoomBox(1).sceneBoundingRect()
      item2=self.selectZoomBox(0).sceneBoundingRect()
      base=Image.open(self.urlim)
      img=base.crop((int(item.x()),int(item.y()),int(item.x()+item.width()),int(item.y()+item.height())))
      img2=base.crop((int(item2.x()),int(item2.y()),int(item2.x()+item2.width()),int(item2.y()+item2.height())))
      (img.resize((w,h))).save(url,"PPM")
      (img2.resize((w,h))).save(url+"end.ppm","PPM")
